#include "fs.h"
#include "misc.h"
#include "proc.h"
#include "const.h"
#include "globales.h"
#include "syscall.h"
#include "asminc.h"
#include "printk.h"

#pragma data_seg ("_BSS", "BSS");
int	linker_end;
int	linker_edata;
int	spini;
unsigned int knd_group;
unsigned int code_seg;
unsigned int data_seg;
unsigned int stack_seg;
long kernel_end;
long first_click;
uint8_t filebuffer[FILEBUFFER_SIZE];	/* se reserva buffer de carga para command.com*/
#pragma data_seg ();



/*===========================================================================*
 *                                   set_vec                                 *
 *===========================================================================*/
/* vec_nr which vector */
/* int (*addr)() where to start */
/* base_click click where kernel sits in memory */
void set_vec(int vec_nr, int (*addr)(), phys_clicks base_click)
{
/* Set up an interrupt vector. */

  unsigned vec[2];
  unsigned u;
  phys_bytes phys_b;
  extern unsigned sizes[8];

  /* Build the vector in the array 'vec'. */
  vec[0] = (unsigned) addr;
  vec[1] = (unsigned) base_click;
  u = (unsigned) vec;

  /* Copy the vector into place. */
  phys_b = logic2phys(stack_seg, u);
  phys_copy(phys_b, (phys_bytes) 4*vec_nr, (phys_bytes) 4);
}



void main()
{
	int i;

	set_vec(SYS_VECTOR, s_call, code_seg);

	kernel_end = logic2phys(data_seg,spini);
	first_click = kernel_end / 16 + 1;

	printk("\nspini: %x", spini);
	printk("\nssini: %x", stack_seg);
	printk("\nInicializando tabla de procesos\n");

	proc[KERNEL_PROC].p_flags = 0;
	proc[KERNEL_PROC].p_parent = 0;
	for (i=1; i<NR_PROCS; i++)
		proc[i].p_flags = P_SLOT_FREE;
	proc_ptr = &proc[KERNEL_PROC];

	printk("Ejecutando command.com\n");

	exec_command_com();

	printk("Sistema operativo terminando...\n");

	return;
}
