segment KNT 		class=CODE align=16 USE16
segment KND 		class=FAR_DATA align=16
segment KND_DATA        class=FAR_DATA align=2
segment KNDCONST        class=FAR_DATA align=2
segment KNDCONST2       class=FAR_DATA align=2
segment KND_BSS         class=BSS align=2
segment KND_STACK	class=STACK align=2

group KND_GROUP KND KNDCONST KNDCONST2 KND_DATA KND_BSS KND_STACK

%define STACK_SIZE 1000h

;CPU 8086

extern 	_end
extern	_edata

segment KNT

global _cstart_
..start:
_cstart_:
	mov	ax,cs
	add 	ax,KND_GROUP
	mov	ds,ax
	mov	es,ax
	
	cli	
	mov	ss,ax
	mov	sp,_end + STACK_SIZE
	sti

	cld
	xor	ax,ax
	mov	di, _edata	; Start of bss is at end of data
	mov	cx, _end	; End of bss (begin of heap)
	sub	cx, di		; Number of bss bytes
	shr	cx, 1		; Number of words
	rep	stosw		; Clear bss
	
	mov	[_linker_end], word _end
	mov	[_linker_edata], word _edata
	mov	[_spini], sp

	extern 	main_
	call 	main_

infinito:
	jmp infinito



global _print_int_asm
_print_int_asm:
	push	bp
	mov	bp,sp
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push 	di
	pushf	
		
        mov     cx,4
        mov	ax,[bp+4]
print_int_lab1:
	rol     ax,4
	push    ax
	and     ax,000fh
	add     ax,TablaChars
       	mov     si,ax
       	lodsb
	push    cx
	mov     ah,0Eh		; Video Function 0Eh
	mov     bx,0007		; Page 0, Mode 7
	int     10h		; of INT 10. 'Tele-type Output' AL = character to write.
	pop    	cx
	pop    	ax
	loop   	print_int_lab1

	popf
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	pop	bp

	ret




global _print_msg_asm
_print_msg_asm:
	push	bp
	mov	bp,sp
	push	ax
	push	bx
	push	cx
	push	dx
	push	si
	push 	di
	pushf
			
	cld
	mov	si,[bp+4]
print_msg_asm_2:	
	lodsb
	or      al,al		; me fijo si ya esta (AL = 00h)
	jz      print_msg_asm_1	; si ya esta, termino
	mov     ah,0Eh		; Video Function 0Eh
	mov     bx,0007		; Page 0, Mode 7
	int     10h		; of INT 10. 'Tele-type Output' AL = character to write
	jmp     print_msg_asm_2	; Loop until done
print_msg_asm_1:	
	popf
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	pop	bp
	ret


global _print_nl_asm
_print_nl_asm:			
	pusha
	mov	al,13			
	mov     ah,0Eh		; Video Function 0Eh
	mov     bx,0007		; Page 0, Mode 7
	int     10h		; of INT 10. 'Tele-type Output' AL = character to write
	mov	al,10			
	mov     ah,0Eh		; Video Function 0Eh
	mov     bx,0007		; Page 0, Mode 7
	int     10h		; of INT 10. 'Tele-type Output' AL = character to write
	popa
	ret

global _putk
_putk:
	push	bp
	mov	bp,sp
	pusha
        mov    	al, [bp+4]	; al = caracter impreso
        test   	al, al		; caracter nulo terminando el string?
        jz      nulch
        cmp    	al, 0Ah		; al = nueva linea? El compilador inserta 0Ah en lugar de '\n' en un string
        jnz     putc
        mov    	al, 0Dh		; Si al == nueva linea == 0Ah, imprimo 0Dh (Caracter Return) previo al fin de linea
	mov	ah, 0Eh  	; Imprime caracter en modo texto
        mov     bx, 0007	; Pagina 0, blanco sobre negro 
        int     10h		; BIOS VIDEO_IO
        mov    	al, 0Ah		; Restauro el caracter de fin de linea y lo imprimo
putc:		
	mov	ah, 0Eh  	; Imprime caracter en modo texto
        mov     bx, 0007	; Pagina 0, blanco sobre negro 
        int     10h		; BIOS VIDEO_IO
nulch:	
	popa
	pop	bp
	ret

			
Segment KNDCONST
TablaChars      	db  '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'

Segment KND_BSS
extern 	_linker_end
extern	_linker_edata
extern	_spini
        
