#include <stdint.h>
#include "misc.h"

extern void printk(const char *fmt, ...);

void reg_dump(uint16_t ax, uint16_t bx, uint16_t cx, uint16_t dx)
{
	printk("AX=: %X\t", (unsigned int)ax);
	printk("BX=: %X\t", (unsigned int)bx);
	printk("CX=: %X\t", (unsigned int)cx);
	printk("DX=: %X\n", (unsigned int)dx);
	return;
}

void sector_dump(uint8_t *sector, int nmax, int nformat)
{
	int i,j;
	int npos = 0;
	for (i=0; i<32; i++)
	{
		for (j=0; j<16; j++)
		{
			if (nformat == FORMATO_DECIMAL)
				printk("%d ", (unsigned int)sector[npos]);
			else
				printk("%X ", (unsigned int)sector[npos]);
			npos++;
			if (npos >= nmax)
				break;
		}
		if (npos >= nmax)
				break;
		printk("\n");
	};
};
