#include "fs.h"
#include "misc.h"
#include "proc.h"
#include "const.h"
#include "globales.h"
#include "syscall.h"
#include "asminc.h"
#include "printk.h"

#pragma data_seg ("_BSS", "BSS");

int	linker_end;
int	linker_edata;
int	spini;
unsigned int knd_group;
unsigned int code_seg;
unsigned int data_seg;
unsigned int stack_seg;
long kernel_end;
long first_click;

#define BSS_ARR_SIZE 8
int bss_arr[BSS_ARR_SIZE];
uint8_t p_commandcom[MAX_COMMANDCOM_SIZE];	/* se reserva buffer de carga para command.com*/
uint8_t p_physcopy_buffer[1000];
uint16_t p_test_src_vector[2];
#pragma data_seg ();


void phys_copy_test_2()
{
	uint16_t vec[2];
	unsigned u;
	long phys_b, org;
	unsigned int i;
	unsigned org_offset;

	u = 35;
	u = (unsigned)vec;
	org_offset = (unsigned)p_test_src_vector;

	phys_b = logic2phys(stack_seg, u);
	org = logic2phys(data_seg,org_offset);

	phys_copy(org, phys_b, 4);

	for (i=0; i<2; i++)
	{
		if (vec[i] != p_test_src_vector[i])
		{
			printk("Error phys_copy_test()\n");
			break;
		};
	};

	if (i==2)
	{
		printk("phys_copy_test() correcto: ");
		printk("vec[0]=%d ",  vec[0]);
		printk("vec[1]=%d\n", vec[1]);
	};

};


/*===========================================================================*
 *                                   set_vec                                 *
 *===========================================================================*/
/* vec_nr which vector */
/* int (*addr)() where to start */
/* base_click click where kernel sits in memory */
void set_vec(int vec_nr, int (*addr)(), phys_clicks base_click)
{
/* Set up an interrupt vector. */

  unsigned vec[2];
  unsigned u;
  phys_bytes phys_b;
  extern unsigned sizes[8];

  /* Build the vector in the array 'vec'. */
  vec[0] = (unsigned) addr;
  vec[1] = (unsigned) base_click;
  u = (unsigned) vec;

  /* Copy the vector into place. */
  phys_b = logic2phys(stack_seg, u);
  phys_copy(phys_b, (phys_bytes) 4*vec_nr, (phys_bytes) 4);
}



void main()
{
	int i;

	uint8_t buffer[SECTOR_SIZE];
	uint8_t unit;
	uint32_t count;
	uint32_t cociente, resto;
	unsigned int *p;
	VOLINFO vi;
	uint8_t sector[SECTOR_SIZE];
	FILEINFO fi;
	long phys_dst;
	long phys_src;
	unsigned linear_src_offset, linear_src_segment;
	unsigned linear_dst_offset, linear_dst_segment;

	print_nl_asm();
	print_msg_asm("Hola Mundo desde C!");
	print_nl_asm();
	printk("este string se imprime con printk(char *)\n");
	printk("Esto es el _end en hexa: %X\n",linker_end);
	print_msg_asm("_end: ");
	print_int_asm(linker_end);
	print_nl_asm();
	print_msg_asm("_edata: ");
	print_int_asm(linker_edata);
	print_nl_asm();
	print_msg_asm("sp inicial: ");
	print_int_asm(spini);
	print_nl_asm();

	print_msg_asm("bss_arr: ");

	for (i=0; i<BSS_ARR_SIZE; i++)
	{
		print_int_asm(bss_arr[i]);
		print_msg_asm(" ");
	};
	print_nl_asm();

	set_vec(SYS_VECTOR, s_call, code_seg);

	kernel_end = logic2phys(data_seg,spini);
	first_click = kernel_end / 16 + 1;

	printk("Inicializando tabla de procesos\n");

	proc[KERNEL_PROC].p_flags = 0;
	proc[KERNEL_PROC].p_parent = 0;
	for (i=1; i<NR_PROCS; i++)
		proc[i].p_flags = P_SLOT_FREE;
	proc_ptr = &proc[KERNEL_PROC];

	printk("Ejecutando command.com\n");

	exec_command_com();

	printk("Sistema operativo terminando...\n");

	return;
}
