#include <stdint.h>
#include "misc.h"
#include "const.h"
#include "proc.h"

extern void printk(const char *fmt, ...);

void reg_dump(uint16_t ax, uint16_t bx, uint16_t cx, uint16_t dx)
{
	printk("AX=: %X\t", (unsigned int)ax);
	printk("BX=: %X\t", (unsigned int)bx);
	printk("CX=: %X\t", (unsigned int)cx);
	printk("DX=: %X\n", (unsigned int)dx);
	return;
}

void sector_dump(uint8_t *sector, int nmax, int nformat)
{
	int i,j;
	int npos = 0;
	for (i=0; i<32; i++)
	{
		for (j=0; j<16; j++)
		{
			if (nformat == FORMATO_DECIMAL)
				printk("%d ", (unsigned int)sector[npos]);
			else
				printk("%X ", (unsigned int)sector[npos]);
			npos++;
			if (npos >= nmax)
				break;
		}
		if (npos >= nmax)
				break;
		printk("\n");
	};
};


long logic2phys(long segment, long offset)
{
	long phys_addr = (segment << CLICK_SHIFT);
	phys_addr = phys_addr + offset;
	return phys_addr;
};

void panic(const char *szMsg)
{
	int i;
	printk("Kernel panic: %s", szMsg);
	while (1)
		i = 0;
};

void proc_dump(struct proc* p)
{
	int i;
	unsigned int * pu;
	printk("Registros:\n");
	for (i=0; i<NR_REGS-1; i++)
		printk("%X\t", (unsigned int)(p->p_reg[i]));
	printk("%X\n", (unsigned int)(p->p_reg[NR_REGS-1]));

	printk("p_pcpsw: ");
	pu = (unsigned int *)(&(p->p_pcpsw));
	for (i=0; i<3; i++)
		printk("%X\t", pu[i]);
	printk("\n");
	return;

};
